POJ 3258 River Hopscotch 二分答案

River Hopscotch

Time Limit: 2000MS   Memory Limit: 65536K
Total Submissions: 6193   Accepted: 2685

Description

Every year the cows hold an event featuring a peculiar version of hopscotch that involves carefully jumping from rock to rock in a river. The excitement takes place on a long, straight river with a rock at the start and another rock at the end, L units
away from the start (1 ≤ L ≤ 1,000,000,000). Along the river between the starting and ending rocks, N (0 ≤ N ≤ 50,000) more rocks appear, each at an integral distance Di from the start (0 < Di <L).

To play the game, each cow in turn starts at the starting rock and tries to reach the finish at the ending rock, jumping only from rock to rock. Of course, less agile cows never make it to the final rock, ending up instead in the river.

Farmer John is proud of his cows and watches this event each year. But as time goes by, he tires of watching the timid cows of the other farmers limp across the short distances between rocks placed too closely together. He plans to remove several rocks in
order to increase the shortest distance a cow will have to jump to reach the end. He knows he cannot remove the starting and ending rocks, but he calculates that he has enough resources to remove up to rocks (0 ≤ M ≤ N).

FJ wants to know exactly how much he can increase the shortest distance *before* he starts removing the rocks. Help Farmer John determine the greatest possible shortest distance a cow has to jump after removing the optimal set of M rocks.

Input

Line 1: Three space-separated integers: LN, and M

Lines 2..N+1: Each line contains a single integer indicating how far some rock is away from the starting rock. No two rocks share the same position.

Output

Line 1: A single integer that is the maximum of the shortest distance a cow has to jump after removing M rocks

Sample Input

25 5 2
2
14
11
21
17

Sample Output

4

Hint

Before removing any rocks, the shortest jump was a jump of 2 from 0 (the start) to 2. After removing the rocks at 2 and 14, the shortest required jump is a jump of 4 (from 17 to 21 or from 21 to 25).

Source

USACO 2006 December Silver

题解

同样是一个二分答案的题目,题意是讲,一个长度为L的河,有N个垫脚石,现在需要去掉m个垫脚石,使得两块石头之间的距离的最小值最大。把河的两岸也看做垫脚石,但是不能去掉他们。

和前几个题目一样,通过二分答案区间就行了。但是这个题目和前几道不同之处在于这个是修改搜索上界时更新res(前几道题都是修改下界时更新)。最后返回res即可。

写出来的效果就是代码示例中的那个样子了。

代码示例

/****
	*@author    Shen
	*@title     poj 1064
	*/

#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
using namespace std;

int n, k;
int l, v[50005];
int maxa = 0;

bool test(int x)
{
    int sum = 0, st = 0;
    for (int i = 1; i <= n + 1; i++)
    {
        if (v[i] - v[st] <= x)
            sum++;
        else
            st = i;
    }
    //printf("\t%s with x = %d, result is that sum = %d.\n", __func__, x, sum);
    return sum <= k;
}

int Bsearch(int l, int r)
{
    int res = r;
    while (l <= r)
    {
        int mid = (r + l) / 2;
        //printf("l = %d, r = %d, mid = %d, res = %d.\n", l, r, mid, res);
        if (test(mid))
             l = mid + 1;
        else
            res = min(res, mid), r = mid - 1;
    }
    return res;
}

void solve()
{
    maxa = l;
    v[0] = 0;
    for (int i = 1; i <= n; i++)
    {
        scanf("%d", &l);
        v[i] = l;
    }
    v[n + 1] = maxa;
    sort(v, v + n + 2);
    int ans = Bsearch(0, maxa);
    printf("%d\n", ans);
}

int main()
{
    while (~scanf("%d%d%d",&l, &n, &k))
        solve();
    return 0;
}

POJ 3258 River Hopscotch 二分答案

时间: 2024-08-27 15:31:42

POJ 3258 River Hopscotch 二分答案的相关文章

[ACM] POJ 3258 River Hopscotch (二分,最大化最小值)

River Hopscotch Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 6697   Accepted: 2893 Description Every year the cows hold an event featuring a peculiar version of hopscotch that involves carefully jumping from rock to rock in a river. T

POJ 3258 River Hopscotch(二分求最小中的最大)

Description Every year the cows hold an event featuring a peculiar version of hopscotch that involves carefully jumping from rock to rock in a river. The excitement takes place on a long, straight river with a rock at the start and another rock at th

POJ - 3258 River Hopscotch 二分

题目大意:给出河的宽度L和N块石头,现在要求移除M块石头,使得石头间的距离的最小值达到最大(起点和终点都有一块石头,但这两块石头不能移除) 解题思路:最小值的最大值,肯定用二分了 如果存在最优的距离,那么移走的石头数量肯定刚好是M块的 枚举的时候判断移除石头的数量,只需要从起点开始枚举,然后计算一下在最小跳跃距离内的石头有几个,有几个就移除几个,最后判断移除了多少个石头 如果移走的数量大于M,就表示所枚举的长度偏大 如果移走的数量小于M,就表示所枚举的长度偏小 有一种比较特殊的情况,就是N =

POJ - 3258 River Hopscotch(二分 最大化最小值)

大致题意: 坐标 从  [0-L], 上有 N 个点 , 现在需要移去 M 个点.求任意两点(包括0,L)点的距离中最小值的最大值 思路:枚举答案,若移去M个点不能达成目标,则使答案变小. while(l <= r){ ll mid = l + (r-l)/2; // 是否可能使得所有石头之间的距离不小于 mid if(check(mid)){ l = mid+1; }else{ r = mid-1; } } printf("%lld\n",l-1); 1 bool check(

POJ 3258 River Hopscotch 经典二分

点击打开链接 River Hopscotch Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 6189   Accepted: 2683 Description Every year the cows hold an event featuring a peculiar version of hopscotch that involves carefully jumping from rock to rock in a r

poj 3258 River Hopscotch 【二分】

题目真是不好读,大意如下(知道题意就很好解了) 大致题意: 一条河长度为 L,河的起点(Start)和终点(End)分别有2块石头,S到E的距离就是L. 河中有n块石头,每块石头到S都有唯一的距离 问现在要移除m块石头(S和E除外),每次移除的是与当前最短距离相关联的石头,要求移除m块石头后,使得那时的最短距离尽可能大,输出那个最短距离. //Memory Time //420K 391MS #include<iostream> #include<algorithm> using

二分搜索 POJ 3258 River Hopscotch

题目传送门 1 /* 2 二分:搜索距离,判断时距离小于d的石头拿掉 3 */ 4 #include <cstdio> 5 #include <algorithm> 6 #include <cstring> 7 #include <cmath> 8 using namespace std; 9 10 typedef long long ll; 11 const int MAXN = 5e4 + 10; 12 const int INF = 0x3f3f3f3

POJ 3258 River Hopscotch(二分&#183;最小距离最大)

题意  一条河两岸之间有n个石头  求取走m个石头后  使得两个石头间距离的最小值最大 感觉关键是理解题意  简单的二分  二分最小距离  看要取走多少个(cnt)石头  cnt<=m的话 说明最小距离还可以增大  这样就可以二分出答案了 #include <cstdio> #include <algorithm> using namespace std; const int N = 50005; int p[N], l, n, m; bool ok(int k) { int

POJ 3258 River Hopscotch (二分)

题目地址:POJ 3258 水题.二分距离,判断是否可行.需要注意的是最后一个,因为最后一个是没法移除的,所以还要倒着判断一下. 代码如下: #include <iostream> #include <string.h> #include <math.h> #include <queue> #include <algorithm> #include <stdlib.h> #include <map> #include &l